# for historical reasons, the package legacy name is mono-nat
%global libname Open.Nat

%global commit0 f288f8dee1688ea744fdf941b49457c782c7575f
%global date0   20160413

# mono is without any packagable debuginfo
%global debug_package %{nil}

# override the .NET Framework Target for predefined types
# https://stackoverflow.com/questions/27594393/compiled-mono-missing-default-net-libraries-system-object-is-not-defined-or-i
#%global xbuild_override xbuild /p:TargetFrameworkVersion="v4.5"

Name:           open-nat
Version:        2.0.11
Release:        2.%{date0}git%(c=%{commit0}; echo ${c:0:7})%{?dist}
Summary:        Library to allow port forwarding in NAT devices that support UPNP
License:        MIT

URL:            https://github.com/lontivero/Open.NAT
Source0:        %{url}/archive/%{commit0}.tar.gz#/%{name}-%{commit0}.tar.gz

BuildRequires:  mono-devel
ExclusiveArch:  %{mono_arches}

%description 
Open.NAT is a lightweight and easy-to-use class library to allow port
forwarding in NAT devices that support UPNP (Universal Plug & Play)
and/or PMP (Port Mapping Protocol).

NATed computers cannot be reached from outside and this is particularly
painful for peer-to-peer or friend-to-friend software. The main goal is
to simplify communication amoung computers behind NAT devices that
support UPNP and/or PMP providing a clean and easy interface to get the
external IP address and map ports and helping you to achieve
peer-to-peer communication. 


%package devel
Summary:        Development files for %{libname}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
%{summary}.


%prep
%setup -qnOpen.NAT-%{commit0}
# tests want LINQ (proprietary at nuget) and M$ internals for XML parsing
sed -i /MS.Internal.Xml.XPath/d %{libname}.Tests/*.cs
# disable nuget
sed -i /NuGet.exe/d %{libname}/%{libname}.csproj
rm -fr .nuget

%build
pushd %{libname}
xbuild /p:Configuration="Debug 4.5" /p:Platform="AnyCPU" %{libname}.csproj

%install
# provided Makefile is useless
mkdir -p %{buildroot}/%{_monogacdir}
gacutil -i %{libname}/bin/Debug/net45/%{libname}.dll -f -package %{name} -root %{buildroot}/usr/lib
# pkgconfig
mkdir -p %{buildroot}/%{_libdir}/pkgconfig
cat <<EOT >>%{buildroot}/%{_libdir}/pkgconfig/%{name}.pc
Name: %{libname}
Description: %{summary}
Version: %{version}
Requires: mono
Libs: -r:%{_monodir}/%{name}/%{libname}.dll
Libraries=%{_monodir}/%{name}/%{libname}.dll
EOT

%check
pushd %{libname}.Tests
xbuild %{libname}.Tests.Net45.csproj
# the test shouldn't last as more than 5sec, mind the ! to negate signal
! timeout 5 mono bin/Debug/Net45/%{libname}.Tests.exe


%files
%license LICENSE
%doc AUTHORS README.md
%doc %{libname}.Tests/
%{_monogacdir}/%{libname}/
%{_monodir}/%{name}/

%files devel
%{_libdir}/pkgconfig/%{name}.pc


%changelog
* Tue Apr 19 2016 Raphael Groner <projects.rg@smart.ms> - 2.0.11-2.20160128gita5c834d
- add license tag
- fix folders ownership
- bump to new github snapshot
- disable nuget
- improve execution of tests

* Wed Mar 02 2016 Raphael Groner <projects.rg@smart.ms> - 2.0.11-1.20160128gita5c834d
- Initial package
